#include "Missile.h"
#include "Game.h" //remove me
#include <cmath>


Missile::Missile()
	:x(400 ),
	y( 580 ),
	Fired ( false),
	Velocity ( 5 ),
	Explode ( false ),
	radius (0)
{
}

int Missile::MissileX()
	{
		return x;
	}
int Missile::MissileY()
	{
		return y;
	}


void Missile::UpdateMissile(D3DGraphics* gfx)
{
	
	if (Fired)
	{	
		int dx = TargetX - x;
		int dy = TargetY - y;
	
		float m = (float)dx / (float)dy;
		float b=x - m*y;

		

		if (y>TargetY)
		{

			Velocity=5 ;
			//Velocity=sqrt ((float)dx + dy);

			y=y-Velocity;

			x = m*y +b + 0.5f;
		}
		else
		{
			Explode = true;
			FireMissile(false, NULL,NULL);
			TargetX=x;
			TargetY=y;
			x=400;
			y=580;
			
	

		}
	}
}

void Missile::FireMissile(bool set, int bX, int bY)
{
	Fired=set;
	TargetX=bX;
	TargetY=bY;

}

void Missile::ExplosionUpdate(D3DGraphics* gfx)
{
	if (Explode)
		{
		
		gfx->DrawDisc(TargetX,TargetY,radius,255,255,255);
		radius++;
		if (radius>50)
		{
		radius=0;
		Explode=false;
			x=400;
		y=580;
		}
	}
}

void Missile::DrawMissile(D3DGraphics* gfx)
{
	
	gfx->PutPixel(0 + x, 0 + y, 29, 5, 1);
	gfx->PutPixel(1 + x, 0 + y, 31, 6, 2);
	gfx->PutPixel(2 + x, 0 + y, 36, 8, 4);
	gfx->PutPixel(3 + x, 0 + y, 39, 8, 3);
	gfx->PutPixel(4 + x, 0 + y, 46, 9, 3);
	gfx->PutPixel(5 + x, 0 + y, 53, 10, 3);
	gfx->PutPixel(6 + x, 0 + y, 60, 11, 4);
	gfx->PutPixel(7 + x, 0 + y, 69, 12, 3);
	gfx->PutPixel(8 + x, 0 + y, 77, 13, 3);
	gfx->PutPixel(9 + x, 0 + y, 82, 14, 3);
	gfx->PutPixel(10 + x, 0 + y, 82, 14, 3);
	gfx->PutPixel(11 + x, 0 + y, 77, 13, 3);
	gfx->PutPixel(12 + x, 0 + y, 71, 13, 2);
	gfx->PutPixel(13 + x, 0 + y, 62, 12, 3);
	gfx->PutPixel(14 + x, 0 + y, 55, 10, 4);
	gfx->PutPixel(15 + x, 0 + y, 48, 9, 2);
	gfx->PutPixel(16 + x, 0 + y, 42, 9, 4);
	gfx->PutPixel(17 + x, 0 + y, 37, 8, 2);
	gfx->PutPixel(18 + x, 0 + y, 32, 7, 3);
	gfx->PutPixel(19 + x, 0 + y, 29, 5, 1);
	gfx->PutPixel(0 + x, 1 + y, 30, 6, 2);
	gfx->PutPixel(1 + x, 1 + y, 32, 7, 2);
	gfx->PutPixel(2 + x, 1 + y, 38, 9, 5);
	gfx->PutPixel(3 + x, 1 + y, 44, 9, 5);
	gfx->PutPixel(4 + x, 1 + y, 50, 9, 3);
	gfx->PutPixel(5 + x, 1 + y, 62, 12, 3);
	gfx->PutPixel(6 + x, 1 + y, 78, 12, 0);
	gfx->PutPixel(7 + x, 1 + y, 88, 17, 0);
	gfx->PutPixel(8 + x, 1 + y, 94, 27, 0);
	gfx->PutPixel(9 + x, 1 + y, 98, 34, 0);
	gfx->PutPixel(10 + x, 1 + y, 97, 34, 1);
	gfx->PutPixel(11 + x, 1 + y, 94, 29, 0);
	gfx->PutPixel(12 + x, 1 + y, 91, 19, 0);
	gfx->PutPixel(13 + x, 1 + y, 83, 14, 0);
	gfx->PutPixel(14 + x, 1 + y, 70, 13, 2);
	gfx->PutPixel(15 + x, 1 + y, 56, 11, 5);
	gfx->PutPixel(16 + x, 1 + y, 47, 10, 4);
	gfx->PutPixel(17 + x, 1 + y, 40, 9, 4);
	gfx->PutPixel(18 + x, 1 + y, 36, 8, 4);
	gfx->PutPixel(19 + x, 1 + y, 31, 7, 3);
	gfx->PutPixel(0 + x, 2 + y, 32, 7, 2);
	gfx->PutPixel(1 + x, 2 + y, 36, 8, 4);
	gfx->PutPixel(2 + x, 2 + y, 41, 8, 3);
	gfx->PutPixel(3 + x, 2 + y, 49, 8, 2);
	gfx->PutPixel(4 + x, 2 + y, 62, 12, 5);
	gfx->PutPixel(5 + x, 2 + y, 83, 13, 1);
	gfx->PutPixel(6 + x, 2 + y, 113, 14, 0);
	gfx->PutPixel(7 + x, 2 + y, 147, 48, 7);
	gfx->PutPixel(8 + x, 2 + y, 197, 127, 58);
	gfx->PutPixel(9 + x, 2 + y, 255, 203, 121);
	gfx->PutPixel(10 + x, 2 + y, 254, 203, 124);
	gfx->PutPixel(11 + x, 2 + y, 209, 142, 72);
	gfx->PutPixel(12 + x, 2 + y, 192, 92, 42);
	gfx->PutPixel(13 + x, 2 + y, 139, 36, 3);
	gfx->PutPixel(14 + x, 2 + y, 93, 14, 0);
	gfx->PutPixel(15 + x, 2 + y, 71, 12, 4);
	gfx->PutPixel(16 + x, 2 + y, 56, 11, 5);
	gfx->PutPixel(17 + x, 2 + y, 46, 11, 5);
	gfx->PutPixel(18 + x, 2 + y, 38, 9, 5);
	gfx->PutPixel(19 + x, 2 + y, 32, 7, 2);
	gfx->PutPixel(0 + x, 3 + y, 34, 6, 2);
	gfx->PutPixel(1 + x, 3 + y, 37, 8, 2);
	gfx->PutPixel(2 + x, 3 + y, 47, 10, 4);
	gfx->PutPixel(3 + x, 3 + y, 61, 11, 2);
	gfx->PutPixel(4 + x, 3 + y, 79, 13, 0);
	gfx->PutPixel(5 + x, 3 + y, 106, 18, 0);
	gfx->PutPixel(6 + x, 3 + y, 189, 75, 39);
	gfx->PutPixel(7 + x, 3 + y, 255, 148, 91);
	gfx->PutPixel(8 + x, 3 + y, 255, 223, 134);
	gfx->PutPixel(9 + x, 3 + y, 255, 239, 136);
	gfx->PutPixel(10 + x, 3 + y, 255, 239, 141);
	gfx->PutPixel(11 + x, 3 + y, 255, 233, 146);
	gfx->PutPixel(12 + x, 3 + y, 255, 197, 128);
	gfx->PutPixel(13 + x, 3 + y, 200, 94, 44);
	gfx->PutPixel(14 + x, 3 + y, 140, 49, 18);
	gfx->PutPixel(15 + x, 3 + y, 89, 16, 0);
	gfx->PutPixel(16 + x, 3 + y, 67, 13, 3);
	gfx->PutPixel(17 + x, 3 + y, 52, 11, 5);
	gfx->PutPixel(18 + x, 3 + y, 43, 10, 5);
	gfx->PutPixel(19 + x, 3 + y, 37, 8, 4);
	gfx->PutPixel(0 + x, 4 + y, 37, 8, 2);
	gfx->PutPixel(1 + x, 4 + y, 43, 10, 3);
	gfx->PutPixel(2 + x, 4 + y, 51, 10, 4);
	gfx->PutPixel(3 + x, 4 + y, 71, 12, 0);
	gfx->PutPixel(4 + x, 4 + y, 101, 14, 0);
	gfx->PutPixel(5 + x, 4 + y, 200, 94, 54);
	gfx->PutPixel(6 + x, 4 + y, 224, 109, 55);
	gfx->PutPixel(7 + x, 4 + y, 233, 135, 64);
	gfx->PutPixel(8 + x, 4 + y, 255, 223, 134);
	gfx->PutPixel(9 + x, 4 + y, 255, 242, 147);
	gfx->PutPixel(10 + x, 4 + y, 255, 242, 150);
	gfx->PutPixel(11 + x, 4 + y, 255, 231, 145);
	gfx->PutPixel(12 + x, 4 + y, 221, 154, 73);
	gfx->PutPixel(13 + x, 4 + y, 255, 215, 143);
	gfx->PutPixel(14 + x, 4 + y, 218, 124, 70);
	gfx->PutPixel(15 + x, 4 + y, 112, 24, 0);
	gfx->PutPixel(16 + x, 4 + y, 79, 16, 0);
	gfx->PutPixel(17 + x, 4 + y, 60, 13, 7);
	gfx->PutPixel(18 + x, 4 + y, 47, 9, 6);
	gfx->PutPixel(19 + x, 4 + y, 39, 8, 5);
	gfx->PutPixel(0 + x, 5 + y, 38, 7, 2);
	gfx->PutPixel(1 + x, 5 + y, 44, 9, 3);
	gfx->PutPixel(2 + x, 5 + y, 56, 11, 5);
	gfx->PutPixel(3 + x, 5 + y, 81, 13, 0);
	gfx->PutPixel(4 + x, 5 + y, 122, 18, 0);
	gfx->PutPixel(5 + x, 5 + y, 240, 126, 66);
	gfx->PutPixel(6 + x, 5 + y, 255, 201, 123);
	gfx->PutPixel(7 + x, 5 + y, 211, 131, 42);
	gfx->PutPixel(8 + x, 5 + y, 232, 175, 85);
	gfx->PutPixel(9 + x, 5 + y, 255, 232, 145);
	gfx->PutPixel(10 + x, 5 + y, 255, 222, 139);
	gfx->PutPixel(11 + x, 5 + y, 190, 135, 52);
	gfx->PutPixel(12 + x, 5 + y, 247, 201, 113);
	gfx->PutPixel(13 + x, 5 + y, 255, 228, 141);
	gfx->PutPixel(14 + x, 5 + y, 255, 201, 128);
	gfx->PutPixel(15 + x, 5 + y, 195, 105, 52);
	gfx->PutPixel(16 + x, 5 + y, 88, 20, 0);
	gfx->PutPixel(17 + x, 5 + y, 64, 14, 7);
	gfx->PutPixel(18 + x, 5 + y, 51, 10, 6);
	gfx->PutPixel(19 + x, 5 + y, 42, 9, 4);
	gfx->PutPixel(0 + x, 6 + y, 41, 8, 3);
	gfx->PutPixel(1 + x, 6 + y, 46, 9, 3);
	gfx->PutPixel(2 + x, 6 + y, 59, 10, 3);
	gfx->PutPixel(3 + x, 6 + y, 88, 13, 0);
	gfx->PutPixel(4 + x, 6 + y, 197, 82, 25);
	gfx->PutPixel(5 + x, 6 + y, 248, 136, 50);
	gfx->PutPixel(6 + x, 6 + y, 255, 223, 110);
	gfx->PutPixel(7 + x, 6 + y, 255, 212, 99);
	gfx->PutPixel(8 + x, 6 + y, 230, 161, 70);
	gfx->PutPixel(9 + x, 6 + y, 225, 146, 69);
	gfx->PutPixel(10 + x, 6 + y, 222, 140, 67);
	gfx->PutPixel(11 + x, 6 + y, 253, 186, 108);
	gfx->PutPixel(12 + x, 6 + y, 255, 243, 149);
	gfx->PutPixel(13 + x, 6 + y, 255, 244, 146);
	gfx->PutPixel(14 + x, 6 + y, 255, 231, 139);
	gfx->PutPixel(15 + x, 6 + y, 215, 141, 70);
	gfx->PutPixel(16 + x, 6 + y, 93, 27, 0);
	gfx->PutPixel(17 + x, 6 + y, 71, 14, 5);
	gfx->PutPixel(18 + x, 6 + y, 54, 11, 5);
	gfx->PutPixel(19 + x, 6 + y, 43, 8, 2);
	gfx->PutPixel(0 + x, 7 + y, 40, 7, 2);
	gfx->PutPixel(1 + x, 7 + y, 47, 10, 4);
	gfx->PutPixel(2 + x, 7 + y, 60, 11, 4);
	gfx->PutPixel(3 + x, 7 + y, 90, 14, 0);
	gfx->PutPixel(4 + x, 7 + y, 198, 80, 18);
	gfx->PutPixel(5 + x, 7 + y, 255, 180, 82);
	gfx->PutPixel(6 + x, 7 + y, 255, 234, 104);
	gfx->PutPixel(7 + x, 7 + y, 255, 242, 112);
	gfx->PutPixel(8 + x, 7 + y, 255, 230, 132);
	gfx->PutPixel(9 + x, 7 + y, 226, 135, 56);
	gfx->PutPixel(10 + x, 7 + y, 202, 112, 36);
	gfx->PutPixel(11 + x, 7 + y, 255, 229, 147);
	gfx->PutPixel(12 + x, 7 + y, 255, 245, 143);
	gfx->PutPixel(13 + x, 7 + y, 254, 228, 118);
	gfx->PutPixel(14 + x, 7 + y, 255, 229, 125);
	gfx->PutPixel(15 + x, 7 + y, 208, 135, 56);
	gfx->PutPixel(16 + x, 7 + y, 97, 28, 0);
	gfx->PutPixel(17 + x, 7 + y, 72, 14, 3);
	gfx->PutPixel(18 + x, 7 + y, 54, 11, 4);
	gfx->PutPixel(19 + x, 7 + y, 45, 8, 2);
	gfx->PutPixel(0 + x, 8 + y, 37, 6, 1);
	gfx->PutPixel(1 + x, 8 + y, 47, 10, 4);
	gfx->PutPixel(2 + x, 8 + y, 60, 11, 4);
	gfx->PutPixel(3 + x, 8 + y, 86, 14, 0);
	gfx->PutPixel(4 + x, 8 + y, 172, 61, 5);
	gfx->PutPixel(5 + x, 8 + y, 255, 161, 68);
	gfx->PutPixel(6 + x, 8 + y, 255, 235, 101);
	gfx->PutPixel(7 + x, 8 + y, 255, 242, 102);
	gfx->PutPixel(8 + x, 8 + y, 255, 229, 118);
	gfx->PutPixel(9 + x, 8 + y, 222, 137, 44);
	gfx->PutPixel(10 + x, 8 + y, 227, 148, 56);
	gfx->PutPixel(11 + x, 8 + y, 255, 196, 99);
	gfx->PutPixel(12 + x, 8 + y, 255, 244, 131);
	gfx->PutPixel(13 + x, 8 + y, 255, 240, 124);
	gfx->PutPixel(14 + x, 8 + y, 255, 218, 113);
	gfx->PutPixel(15 + x, 8 + y, 199, 116, 38);
	gfx->PutPixel(16 + x, 8 + y, 95, 26, 0);
	gfx->PutPixel(17 + x, 8 + y, 69, 15, 5);
	gfx->PutPixel(18 + x, 8 + y, 53, 10, 3);
	gfx->PutPixel(19 + x, 8 + y, 43, 8, 2);
	gfx->PutPixel(0 + x, 9 + y, 38, 7, 2);
	gfx->PutPixel(1 + x, 9 + y, 44, 9, 3);
	gfx->PutPixel(2 + x, 9 + y, 56, 12, 3);
	gfx->PutPixel(3 + x, 9 + y, 81, 13, 0);
	gfx->PutPixel(4 + x, 9 + y, 123, 20, 0);
	gfx->PutPixel(5 + x, 9 + y, 219, 116, 37);
	gfx->PutPixel(6 + x, 9 + y, 252, 182, 61);
	gfx->PutPixel(7 + x, 9 + y, 255, 216, 83);
	gfx->PutPixel(8 + x, 9 + y, 232, 150, 38);
	gfx->PutPixel(9 + x, 9 + y, 255, 174, 71);
	gfx->PutPixel(10 + x, 9 + y, 255, 229, 126);
	gfx->PutPixel(11 + x, 9 + y, 227, 163, 57);
	gfx->PutPixel(12 + x, 9 + y, 250, 189, 82);
	gfx->PutPixel(13 + x, 9 + y, 255, 219, 115);
	gfx->PutPixel(14 + x, 9 + y, 255, 207, 117);
	gfx->PutPixel(15 + x, 9 + y, 186, 98, 34);
	gfx->PutPixel(16 + x, 9 + y, 87, 20, 0);
	gfx->PutPixel(17 + x, 9 + y, 63, 13, 4);
	gfx->PutPixel(18 + x, 9 + y, 50, 9, 3);
	gfx->PutPixel(19 + x, 9 + y, 42, 9, 2);
	gfx->PutPixel(0 + x, 10 + y, 36, 7, 1);
	gfx->PutPixel(1 + x, 10 + y, 41, 8, 1);
	gfx->PutPixel(2 + x, 10 + y, 52, 9, 2);
	gfx->PutPixel(3 + x, 10 + y, 74, 12, 0);
	gfx->PutPixel(4 + x, 10 + y, 106, 15, 0);
	gfx->PutPixel(5 + x, 10 + y, 207, 100, 44);
	gfx->PutPixel(6 + x, 10 + y, 255, 162, 70);
	gfx->PutPixel(7 + x, 10 + y, 236, 121, 14);
	gfx->PutPixel(8 + x, 10 + y, 215, 103, 3);
	gfx->PutPixel(9 + x, 10 + y, 255, 206, 103);
	gfx->PutPixel(10 + x, 10 + y, 255, 227, 111);
	gfx->PutPixel(11 + x, 10 + y, 255, 192, 82);
	gfx->PutPixel(12 + x, 10 + y, 226, 114, 28);
	gfx->PutPixel(13 + x, 10 + y, 228, 106, 39);
	gfx->PutPixel(14 + x, 10 + y, 236, 133, 75);
	gfx->PutPixel(15 + x, 10 + y, 108, 25, 0);
	gfx->PutPixel(16 + x, 10 + y, 78, 15, 0);
	gfx->PutPixel(17 + x, 10 + y, 59, 12, 6);
	gfx->PutPixel(18 + x, 10 + y, 47, 10, 4);
	gfx->PutPixel(19 + x, 10 + y, 39, 8, 3);
	gfx->PutPixel(0 + x, 11 + y, 35, 6, 2);
	gfx->PutPixel(1 + x, 11 + y, 39, 8, 3);
	gfx->PutPixel(2 + x, 11 + y, 47, 8, 1);
	gfx->PutPixel(3 + x, 11 + y, 63, 11, 0);
	gfx->PutPixel(4 + x, 11 + y, 87, 12, 0);
	gfx->PutPixel(5 + x, 11 + y, 116, 18, 0);
	gfx->PutPixel(6 + x, 11 + y, 224, 100, 38);
	gfx->PutPixel(7 + x, 11 + y, 210, 79, 1);
	gfx->PutPixel(8 + x, 11 + y, 225, 103, 20);
	gfx->PutPixel(9 + x, 11 + y, 247, 139, 48);
	gfx->PutPixel(10 + x, 11 + y, 255, 192, 87);
	gfx->PutPixel(11 + x, 11 + y, 246, 152, 56);
	gfx->PutPixel(12 + x, 11 + y, 255, 125, 61);
	gfx->PutPixel(13 + x, 11 + y, 197, 64, 21);
	gfx->PutPixel(14 + x, 11 + y, 126, 26, 0);
	gfx->PutPixel(15 + x, 11 + y, 90, 15, 0);
	gfx->PutPixel(16 + x, 11 + y, 68, 11, 0);
	gfx->PutPixel(17 + x, 11 + y, 51, 10, 4);
	gfx->PutPixel(18 + x, 11 + y, 43, 8, 4);
	gfx->PutPixel(19 + x, 11 + y, 37, 8, 2);
	gfx->PutPixel(0 + x, 12 + y, 33, 5, 2);
	gfx->PutPixel(1 + x, 12 + y, 36, 7, 3);
	gfx->PutPixel(2 + x, 12 + y, 43, 8, 2);
	gfx->PutPixel(3 + x, 12 + y, 52, 9, 2);
	gfx->PutPixel(4 + x, 12 + y, 65, 11, 0);
	gfx->PutPixel(5 + x, 12 + y, 87, 12, 0);
	gfx->PutPixel(6 + x, 12 + y, 113, 12, 0);
	gfx->PutPixel(7 + x, 12 + y, 185, 70, 26);
	gfx->PutPixel(8 + x, 12 + y, 220, 106, 46);
	gfx->PutPixel(9 + x, 12 + y, 248, 131, 62);
	gfx->PutPixel(10 + x, 12 + y, 231, 113, 41);
	gfx->PutPixel(11 + x, 12 + y, 231, 111, 48);
	gfx->PutPixel(12 + x, 12 + y, 214, 95, 52);
	gfx->PutPixel(13 + x, 12 + y, 120, 16, 0);
	gfx->PutPixel(14 + x, 12 + y, 91, 14, 0);
	gfx->PutPixel(15 + x, 12 + y, 71, 13, 1);
	gfx->PutPixel(16 + x, 12 + y, 57, 10, 4);
	gfx->PutPixel(17 + x, 12 + y, 47, 9, 6);
	gfx->PutPixel(18 + x, 12 + y, 39, 8, 5);
	gfx->PutPixel(19 + x, 12 + y, 34, 6, 2);
	gfx->PutPixel(0 + x, 13 + y, 30, 5, 1);
	gfx->PutPixel(1 + x, 13 + y, 34, 6, 2);
	gfx->PutPixel(2 + x, 13 + y, 38, 7, 2);
	gfx->PutPixel(3 + x, 13 + y, 46, 9, 3);
	gfx->PutPixel(4 + x, 13 + y, 53, 10, 3);
	gfx->PutPixel(5 + x, 13 + y, 66, 9, 0);
	gfx->PutPixel(6 + x, 13 + y, 87, 9, 0);
	gfx->PutPixel(7 + x, 13 + y, 100, 9, 0);
	gfx->PutPixel(8 + x, 13 + y, 113, 17, 0);
	gfx->PutPixel(9 + x, 13 + y, 124, 19, 0);
	gfx->PutPixel(10 + x, 13 + y, 174, 57, 13);
	gfx->PutPixel(11 + x, 13 + y, 127, 13, 0);
	gfx->PutPixel(12 + x, 13 + y, 111, 13, 0);
	gfx->PutPixel(13 + x, 13 + y, 90, 11, 0);
	gfx->PutPixel(14 + x, 13 + y, 71, 11, 1);
	gfx->PutPixel(15 + x, 13 + y, 55, 10, 4);
	gfx->PutPixel(16 + x, 13 + y, 48, 9, 4);
	gfx->PutPixel(17 + x, 13 + y, 42, 9, 4);
	gfx->PutPixel(18 + x, 13 + y, 36, 6, 4);
	gfx->PutPixel(19 + x, 13 + y, 33, 5, 2);
	gfx->PutPixel(0 + x, 14 + y, 28, 5, 0);
	gfx->PutPixel(1 + x, 14 + y, 30, 7, 1);
	gfx->PutPixel(2 + x, 14 + y, 34, 6, 2);
	gfx->PutPixel(3 + x, 14 + y, 39, 8, 3);
	gfx->PutPixel(4 + x, 14 + y, 45, 8, 0);
	gfx->PutPixel(5 + x, 14 + y, 53, 9, 0);
	gfx->PutPixel(6 + x, 14 + y, 62, 7, 0);
	gfx->PutPixel(7 + x, 14 + y, 71, 9, 0);
	gfx->PutPixel(8 + x, 14 + y, 78, 11, 0);
	gfx->PutPixel(9 + x, 14 + y, 84, 12, 0);
	gfx->PutPixel(10 + x, 14 + y, 88, 10, 0);
	gfx->PutPixel(11 + x, 14 + y, 87, 10, 0);
	gfx->PutPixel(12 + x, 14 + y, 76, 9, 0);
	gfx->PutPixel(13 + x, 14 + y, 67, 9, 0);
	gfx->PutPixel(14 + x, 14 + y, 56, 7, 0);
	gfx->PutPixel(15 + x, 14 + y, 47, 8, 1);
	gfx->PutPixel(16 + x, 14 + y, 42, 9, 2);
	gfx->PutPixel(17 + x, 14 + y, 37, 8, 2);
	gfx->PutPixel(18 + x, 14 + y, 33, 5, 2);
	gfx->PutPixel(19 + x, 14 + y, 30, 4, 3);

}