#pragma once
#include <d3d9.h>


struct BitmapFileHeader
{

	unsigned int fileSize;
	unsigned short int reserved1, reserved2;
	unsigned int offsetToPixelData;

};

struct BitmapInfoHeader
{
	unsigned int headerSize;
	unsigned int width, height;
	unsigned short planes;
	unsigned short bits;
	unsigned int compression;
	unsigned int imageSize;
	unsigned xResolution, yResolution;
	unsigned int nColours;
	unsigned int importantColours;
};

struct Pixel24
{
	unsigned char blue;
	unsigned char green;
	unsigned char red;
};

void LoadBmp ( const char* filename, D3DCOLOR* surface);